UNIT Atari;  { V 2.00 }

 { (C)opyright by ONKISOFT 1999, das ist
          Gero Zahn
          Bergring 27
        D-4953 Petershagen
          Tel.: 05707/2501

    Hiermit werden zwei der beliebten Atari-Tos-Funktionen unter
    Turbo-Pascal 4.0 bereitgestellt: Die Alertbox und die Fileselectbox.
    Hinzugekommen ist mit der neuen Version 2.0 noch die Mglichkeit,
    Pulldown-Mens "hnlich" wie beim darzustellen. Sptestens jetzt
    bekommen Turbo Pascal-Programme einen "ATARI-Anstrich" ...
    Ntig ist das Unit Lowgraph, zu erhalten auch bei mir, ntig ist
    Version 1.xx ab 1.3 oder 2.xx ab 2.21. }

 INTERFACE

 uses crt,dos,lowgraph;

 TYPE ArtTyp=(Name,Ext,Size);  { Sortierung nach Name, Extension oder Gre }
      HandleTyp=(Auto,Manu);

 CONST SortArt:arttyp=name;       { Bei FileSelect wird defaultmig
                                    nach Name sortiert }

       PathHandle:handletyp=auto; { Bei Auto bernimmt FileSelect das
                                    Path-Handling (den Pfadwechsel), bei
                                    Manu mu der User den Pfad selbst
                                    manipulieren }


 PROCEDURE alert(icn:BYTE;mstring:STRING;default:BYTE;bstring:STRING;
                 VAR an:BYTE);

      { icn = 0 : Kein Icon
              1 : Ausrufezeichen
              2 : Fragezeichen
              3 : Stopschild
        mstring = Message, maximal vier Zeilen mit maximal 30 Zeichen,
                  Zeilen durch "|" getrennt
        default = doppelt umrandeter Button, der mit "CR" gewhlt werden kann
        bstring = Buttons, maximal drei, maximal 8 Zeichen lang
         VAR an = Antwort, ergibt die Nummer des gewhlten Buttons }

 PROCEDURE fileselect(VAR path,nam:STRING; prenam:STRING; VAR cancel:BOOLEAN);

            { VAR path : Name eines Pfades + Extension. Eine fehlende
                         Extension wird durch '*.*' ergnzt.
                         Zulssig wre: path:=ActivePath.
              VAR name : Hier wird spter ein Filename (inklusive Pfad)
                         herausgereicht.
               prename : Default-Name, der spter herausgereicht werden kann.
                         Nur 'name.ext' ist zulssig!
            VAR cancel : Wird die Box mit 'A' verlassen, ist cancel TRUE,
                         ansonsten FALSE. }

 FUNCTION ActivePath:STRING; { Ergibt den aktuellen Pfad im aktuellen Drive }

 FUNCTION prepared:BOOLEAN; { Ist die BAR betriebsbereit? }

 PROCEDURE clear_bar;  { Alle Men-Daten lschen }

 PROCEDURE make_menu(title,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10:STRING);
           { Ein Pull-Down-Men anhngen }

 PROCEDURE make_bar; { Komplette Menzeile vorbereiten }

 PROCEDURE do_menu(VAR men_nr,eint_nr:INTEGER);
           { Menzeile einblenden, Ergbnis:
                men_nr : Nummer des Mens (von links)
                ent_nr : Nummer des Eintrags (von oben)
                  (0/0) -> Abbruch der Zeile ber ESC }

 PROCEDURE selectable(men_nr,eint_nr:INTEGER);
           { Einen Eintrag whlbar machen }

 PROCEDURE unselectable(men_nr,eint_nr:INTEGER);
           { Einen Eintrag nicht whlbar machen }

 FUNCTION men_text(men,eint:INTEGER):STRING;
          { ergibt den Text eines Meneintrages }

 IMPLEMENTATION

 CONST icon:ARRAY[0..3,1..6] OF STRING = (('','','','','',''),
(
'   _   ',
'  / \  ',
' /   \ ',
'|  !  |',
' \   / ',
'  \_/  '),
(
'   _   ',
'  / \  ',
' /   \ ',
'|  ?  |',
' \   / ',
'  \_/  '),
(
'   _   ',
'  / \  ',
' /   \ ',
'|STOP!|',
' \   / ',
'  \_/  '));

 CONST lin:ARRAY[1..2,1..6] OF CHAR=(('','','','','',''),
                                     ('','','','','',''));

 TYPE eint_typ=RECORD
                txt:STRING;
                wbar:BOOLEAN;
               END;
      menu_typ=RECORD
                men_name:STRING;
                eint_anz:INTEGER;
                men_eint:ARRAY[1..10] OF eint_typ;
               END;
      bar_typ=RECORD
               menu:ARRAY[1..10] OF menu_typ;
               anz:INTEGER;
              END;

 VAR oldscreen:bildptr;
     oldx,oldy,oldattr:BYTE;
     OldWindMin,OldWindMax:WORD;
     oldbrk:BOOLEAN;

 VAR men_bar:bar_typ;
     men_ok:BOOLEAN;
     bar_line:STRING;
     bar_pos:ARRAY[1..10] OF RECORD
                              posi,len:INTEGER;
                             END;
     act_menu:INTEGER;

  PROCEDURE save_all;
   BEGIN
    oldx:=WHEREX; oldy:=WHEREY;
    SGET(oldscreen^);
    oldattr:=TextAttr; TextAttr:=White;
    oldbrk:=CheckBreak; Checkbreak:=FALSE;
    cursor_aus;
    OldWindMin:=WindMin; WindMin:=$0000;
    OldWindMax:=WindMax; WindMax:=$184f;
   END;

  PROCEDURE restore_all;
   BEGIN
    WindMin:=OldWindMin;
    WindMax:=OldWindMax;
    GOTOXY(oldx,oldy);
    SPUT(oldscreen^);
    TextAttr:=OldAttr;
    Checkbreak:=oldbrk;
    cursor_norm;
   END;

  FUNCTION strg(what:STRING; anz:INTEGER):STRING;
   VAR hstr:STRING;
       cnt:BYTE;
   BEGIN
    hstr:='';
    FOR cnt:=1 TO anz DO hstr:=hstr+what;
    strg:=hstr;
   END;

  PROCEDURE draw_box(xp,yp,xl,yl,d:INTEGER);
   VAR blanklin,linelin:STRING;
       zlr:INTEGER;
   BEGIN
    blanklin:=lin[d,5]+strg(' ',xl-2)+lin[d,5];
    linelin:=strg(lin[d,6],xl-2);
    GOTOXY(xp,yp);
    WRITE(lin[d,1],linelin,lin[d,2]);
    FOR zlr:=1 TO yl-2 DO
     BEGIN
      GOTOXY(xp,yp+zlr);
      WRITE(blanklin);
     END;
    GOTOXY(xp,yp+yl-1);
    WRITE(lin[d,3],linelin,lin[d,4]);
   END;

 PROCEDURE alert(icn:BYTE;mstring:STRING;default:BYTE;bstring:STRING;
                 VAR an:BYTE);
  VAR cnt,anz,ll:BYTE;
      postas:SET OF CHAR;
      tas:CHAR;
      messages:ARRAY[1..6] OF STRING;
      buttons:ARRAY[1..3] OF STRING;
  PROCEDURE extract(VAR anz:BYTE);
   VAR cnt,posi:BYTE;
       cstr:STRING;
   BEGIN
    mstring:=mstring+'|';
    FOR cnt:=1 TO 6 DO
     BEGIN
      messages[cnt]:=icon[icn,cnt];
      IF cnt IN [2..5] THEN
       BEGIN
        posi:=pos('|',mstring);
        IF posi<>0 THEN
         BEGIN
          messages[cnt]:=messages[cnt]+' '+COPY(mstring,1,posi-1);
          DELETE(mstring,1,posi);
          posi:=pos('|',mstring);
         END;
       END;
     END;
    bstring:=bstring+'|';
    FOR cnt:=1 TO 3 DO
     BEGIN
      buttons[cnt]:='';
      posi:=pos('|',bstring);
      IF posi<>0 THEN
       BEGIN
        buttons[cnt]:=COPY(bstring,1,posi-1);
        DELETE(bstring,1,posi);
        posi:=pos('|',bstring);
        IF buttons[cnt]<>'' THEN anz:=cnt;
        str(cnt,cstr);
        buttons[cnt]:=cstr+':'+buttons[cnt];
       END;
     END;
   END;
  PROCEDURE make_len(VAR ll:BYTE; anz:BYTE);
   VAR cnt,tem:BYTE;
   BEGIN
    ll:=0;
    FOR cnt:=1 TO 6 DO IF ll<LENGTH(messages[cnt]) THEN
                         ll:=LENGTH(messages[cnt]);
    tem:=0;
    FOR cnt:=1 TO anz DO tem:=tem+2+LENGTH(buttons[cnt]);
    IF ll<tem THEN ll:=tem;
   END;
  PROCEDURE draw_alert(ll,anz,def:BYTE);
   VAR cnt,xp,tem:BYTE;
   BEGIN
    xp:=(80-(ll+2)) DIV 2;
    draw_box(xp,8,ll+2,11,2);
    FOR cnt:=1 TO 6 DO
     BEGIN
      GOTOXY(xp+1,8+cnt);
      WRITELN(messages[cnt]);
     END;
    tem:=0;
    FOR cnt:=1 TO anz DO tem:=tem+2+LENGTH(buttons[cnt]);
    xp:=xp+(ll-tem) DIV 2+1;
    FOR cnt:=1 TO anz DO
     BEGIN
      ll:=Length(buttons[cnt])+2;
      IF cnt=def THEN draw_box(xp,15,ll,3,2)
                 ELSE draw_box(xp,15,ll,3,1);
      GOTOXY(xp+1,16);
      WRITE(buttons[cnt]);
      xp:=xp+ll;
     END;
   END;
  BEGIN
   save_all;
   icn:=icn MOD 4;
   IF bstring='' THEN bstring:=' ';
   extract(anz);
   make_len(ll,anz);
   draw_alert(ll,anz,default);
   postas:=[];
   IF (default>0) AND (default<=anz) THEN postas:=postas+[#13];
   FOR cnt:=1 TO anz DO
    BEGIN
     postas:=postas+[chr(cnt+48)];   {              1..3  }
     postas:=postas+[chr(cnt+58)];   {             F1..F3 }
     postas:=postas+[chr(cnt+78)];   { Cursor-Block 1..3  }
    END;
   REPEAT
    tas:=READKEY;
    IF keypressed THEN tas:=READKEY;
   UNTIL tas IN postas;
   CASE tas OF  ^m : an:=default;
               '1',';','O' : an:=1;
               '2','<','P' : an:=2;
               '3','=','Q' : an:=3;
            END; {CASE}
   restore_all;
  END;

 PROCEDURE fileselect(VAR path,nam:STRING; prenam:STRING; VAR cancel:BOOLEAN);

 CONST legal:SET OF CHAR=['$'..')','-','0'..'9','@'..'Z',
                          '^','_','{','}','!','#'];
       lpath='________________________';
       lfil='________.___';

 TYPE feldtyp=RECORD
               belegt:INTEGER;
               inhalt:ARRAY[1..256] OF SearchRec;
              END;
      feldptr=^feldtyp;
      menge=SET OF CHAR;

VAR feld:feldptr;
    hpath:STRING;

 FUNCTION last_bs(was:STRING):INTEGER;
  VAR zlr:INTEGER;
  BEGIN
   zlr:=LENGTH(was);
   WHILE was[zlr]<>'\' DO DEC(zlr);
   last_bs:=zlr;
  END;

 PROCEDURE conv_rec(VAR rec:SearchRec);
  BEGIN
   WITH rec DO
    BEGIN
     IF pos('.',name)=0 THEN name:=name+'.';
     name:=COPY(COPY(name,1,pos('.',name)-1)+'        ',1,8)+'.'
           +COPY(name+'   ',pos('.',name)+1,3);
    END;
  END;

 PROCEDURE get_dir(pth:STRING; VAR feld:feldtyp; art:arttyp);
  VAR allpath:STRING;
      hilf:INTEGER;
      rec:SearchRec;
  FUNCTION kleiner_rec(rec1,rec2:SearchRec; art:arttyp):BOOLEAN;
   VAR ext1,ext2:STRING;
   BEGIN
    CASE art OF name : kleiner_rec:=(rec1.name<rec2.name);
                size : BEGIN
                        IF rec1.size=rec2.size
                          THEN kleiner_rec:=(rec1.name<rec2.name)
                          ELSE kleiner_rec:=(rec1.size<rec2.size);
                       END;
                ext  : BEGIN
                        ext1:=COPY(rec1.name,10,3);
                        ext2:=COPY(rec2.name,10,3);
                        IF ext1=ext2 THEN kleiner_rec:=(rec1.name<rec2.name)
                                     ELSE kleiner_rec:=(ext1<ext2);
                       END;
               END;
   END;
  PROCEDURE insert_rec(rec:SearchRec; VAR feld:feldtyp; art:arttyp;
                       von:INTEGER);
   VAR such,zlr:INTEGER;
   BEGIN
    conv_rec(rec);
    WITH feld DO
     BEGIN
      IF belegt-von=0 THEN
       BEGIN
        INC(belegt);
        inhalt[belegt]:=rec;
       END ELSE
       BEGIN
        such:=von+1;
        WHILE (such<belegt) AND kleiner_rec(inhalt[such],rec,art) DO INC(such);
        INC(belegt);
        IF kleiner_rec(inhalt[such],rec,art) THEN inhalt[belegt]:=rec ELSE
         BEGIN
          FOR zlr:=belegt DOWNTO such+1 DO inhalt[zlr]:=inhalt[zlr-1];
          inhalt[such]:=rec;
         END;
       END;
     END;
   END;
  BEGIN
   WITH feld DO
    BEGIN
     belegt:=0;
     allpath:=COPY(path,0,last_bs(path))+'*.*';
     FindFirst(allpath,AnyFile,rec);
     WHILE DosError=0 DO
      BEGIN
       IF (rec.Attr AND Directory)<>0 THEN
        IF (rec.name<>'.') AND (rec.name<>'..') THEN
         insert_rec(rec,feld,art,0);
       FindNext(rec);
      END;
     hilf:=belegt;
     FindFirst(path,AnyFile,rec);
     WHILE DosError=0 DO
      BEGIN
       IF ((rec.attr AND Directory)=0) AND ((rec.attr AND VolumeID)=0) THEN
        insert_rec(rec,feld,art,hilf);
       FindNext(rec);
      END;
    END;
  END;

 PROCEDURE at(xp,yp:INTEGER; txt:STRING);
  BEGIN
   GOTOXY(xp,yp);
   WRITE(txt);
  END;

 PROCEDURE draw_fsel(art:arttyp);
  VAR zlr:INTEGER;
  BEGIN
   draw_box(23,3,33,22,2); { Hauptrand }
   draw_box(25,11,18,13,2); { Files }
   draw_box(25,11,16,13,1);
   draw_box(25,11,18,11,1);
   draw_box(25,11,16,11,1);
   CASE art OF name : put(41,22,'N');
               ext  : put(41,22,'E');
               size : put(41,22,'S');
            END;
   put(25,21,''); put(40,11,''); put(40,21,'');
   draw_box(43,12,11,5,1); { OK/Abbruch }
   at(43,14,''+strg('',9)+'');
   draw_box(44,18,8,5,1); { Sort }
   at(32,5,'OBJEKT AUSWAHL');
   at(26,7,':');
   at(26,9,'Auswahl 0:');
   FOR zlr:=0 TO 8 DO
    BEGIN
     put(26,12+zlr,chr(ord('1')+zlr));
     put(27,12+zlr,':');
     put(41,12+zlr,'');
    END;
   at(26,22,'ESC: Schlieen');
   at(44,13,'<CR>: OK');
   at(44,15,'<A>bbruch');
   at(45,19,'<N>ame');
   at(45,20,'<E>xt');
   at(45,21,'<S>ize');
  END;

 FUNCTION upca(was:STRING):STRING;
  VAR zlr:INTEGER;
  BEGIN
   FOR zlr:=1 TO LENGTH(was) DO was[zlr]:=UPCASE(was[zlr]);
   upca:=was;
  END;

 PROCEDURE show_path(VAR path,nam:STRING);
  VAR hpath:STRING;
      posi:INTEGER;
      hrec:SearchRec;
  BEGIN
   path:=UPCA(path);
   posi:=pos(':',path);
   IF posi<>0 THEN path:=COPY(path,1,posi)+'\'+COPY(path,posi+1,255)
              ELSE path:='\'+path;
   REPEAT
    posi:=pos('\\',path);
    IF posi<>0 THEN DELETE(path,posi,1);
   UNTIL posi=0;
   IF path[LENGTH(path)]='\' THEN path:=path+'*.*';
   IF LENGTH(path)<=24 THEN hpath:=path ELSE
      hpath:='...'+COPY(path,LENGTH(path)-20,21);
   at(29,7,lpath);
   at(29,7,hpath);
   nam:=UPCA(nam);
   IF pos('.',nam)=0 THEN nam:=nam+'.';
   WHILE pos('.',nam)>9 DO DELETE(nam,9,1);
   hrec.name:=nam;
   conv_rec(hrec);
   nam:=hrec.name;
   at(37,9,nam);
  END;

 PROCEDURE prepare_screen(VAR path,nam:STRING; VAR feld:feldtyp; art:arttyp);
  BEGIN
   cursor_aus;
   draw_fsel(art);
   show_path(path,nam);
   get_dir(path,feld,art);
   cursor_norm;
  END;

 PROCEDURE fsel(VAR path,nam:STRING; VAR feld:feldtyp; VAR art:arttyp;
                VAR abgebrochen:BOOLEAN);
  VAR posi,altposi,roll:INTEGER;
      tas:CHAR;
  PROCEDURE show(posi:INTEGER);
   VAR zlr:INTEGER;
   BEGIN
    WITH feld DO
     BEGIN
      FOR zlr:=posi TO posi+8 DO
       BEGIN
        IF zlr<=belegt THEN
         BEGIN
          IF inhalt[zlr].attr=directory THEN
           BEGIN
            LOWVIDEO;
            put(27,12+zlr-posi,'>');
           END ELSE put(27,12+zlr-posi,':');
          at(28,12+zlr-posi,inhalt[zlr].name);
          HIGHVIDEO;
          put(41,12+zlr-posi,'');
         END ELSE at(28,12+zlr-posi,lfil);
       END;
      IF belegt<=9 THEN roll:=0 ELSE roll:=((posi-1)*8) DIV (belegt-9);
      put(41,12+roll,'');
     END;
    GOTOXY(37,9);
   END;
  PROCEDURE close_folder(VAR path,nam:STRING;VAR posi,altposi:INTEGER;art:arttyp);
   VAR hilf:STRING;
   BEGIN
    posi:=1;
    altposi:=last_bs(path);
    hilf:=COPY(path,altposi+1,255);
    path:=COPY(path,1,altposi-1);
    IF pos('\',path)=0 THEN path:=path+'\'+hilf ELSE
          path:=COPY(path,1,last_bs(path))+hilf;
    altposi:=0;
    prepare_screen(path,nam,feld,art);
   END;
  PROCEDURE change_art(VAR path,nam:STRING;VAR posi,altposi:INTEGER;
                       VAR art:arttyp; tas:CHAR);
   BEGIN
    posi:=1;
    altposi:=0;
    CASE tas OF 'N' : art:=name;
                'E' : art:=ext;
                'S' : art:=size;
             END;
    prepare_screen(path,nam,feld,art);
   END;
  PROCEDURE input(xpos,ypos,len:INTEGER; VAR was:STRING;
                  leer:CHAR; abbr:menge; erlaubt:menge);
   VAR posi,waslen:INTEGER;
       lstr,tasstr:STRING;
   PROCEDURE restyle;
    BEGIN
     at(xpos,ypos,was);
     IF waslen<len THEN WRITE(leer);
     GOTOXY(xpos+(posi-1),ypos);
    END;
   BEGIN
    cursor_voll;
    IF waslen>len THEN was:=COPY(was,1,len);
    lstr:=strg(leer,len);
    at(xpos,ypos,lstr);
    waslen:=LENGTH(was);
    posi:=waslen+1;
    restyle;
    REPEAT
     tas:=UPCASE(READKEY);
     IF keypressed THEN
      BEGIN
       tas:=READKEY;
       CASE tas OF 'M' : INC(posi);
                   'K' : DEC(posi);
                END;
       IF posi<1 THEN posi:=1;
       IF posi>waslen+1 THEN posi:=waslen+1;
       GOTOXY(xpos+posi-1,ypos);
      END ELSE
       BEGIN
        CASE tas OF  ^h : IF posi>1 THEN
                           BEGIN
                            DELETE(was,posi-1,1);
                            DEC(posi);
                            DEC(waslen);
                            restyle;
                           END
                 END;
        IF (tas IN legal+erlaubt) AND (waslen<len) THEN
         BEGIN
          tasstr:=tas;
          INSERT(tasstr,was,posi);
          INC(posi);
          INC(waslen);
          restyle;
         END;
       END;
    UNTIL tas IN abbr;
    cursor_norm;
   END;
  PROCEDURE enter_path(VAR path,nam:STRING;VAR posi,altposi:INTEGER;
                       art:arttyp);
   VAR npath:STRING;
   BEGIN
    posi:=0;
    altposi:=0;
    npath:=path;
    REPEAT
     input(29,7,24,npath,' ',[^m,#27],['.','\',':','*']);
     IF tas=#27 THEN npath:='';
    UNTIL tas<>#27;
    IF npath<>'' THEN path:=npath;
    prepare_screen(path,nam,feld,art);
    tas:=#0;
   END;
  PROCEDURE enter_name(VAR nam:STRING);
   VAR nn,ex:STRING;
       hrec:SearchRec;
   PROCEDURE cut(VAR st:STRING);
    BEGIN
     WHILE st[LENGTH(st)]=' ' DO DELETE(st,LENGTH(st),1);
    END;
   PROCEDURE clear_nam;
    BEGIN
     nn:='';
     ex:='';
     at(37,9,lfil);
    END;
   BEGIN
    nn:=COPY(nam,1,pos('.',nam)-1);     cut(nn);
    ex:=COPY(nam,pos('.',nam)+1,3);     cut(ex);
    REPEAT
     REPEAT
      input(37,9,8,nn,'_',[^m,#27,'.'],[]);
      IF tas=#27 THEN clear_nam;
     UNTIL tas<>#27;
     IF tas='.' THEN
      BEGIN
       input(46,9,3,ex,'_',[^m,#27],[]);
       IF tas=#27 THEN clear_nam;
      END;
    UNTIL tas<>#27;
    hrec.name:=nn+'.'+ex;
    conv_rec(hrec);
    nam:=hrec.name;
    at(37,9,nam);
    GOTOXY(37,9);
    tas:=#0;
   END;
  PROCEDURE change_name(VAR path,nam:STRING;VAR posi,altposi:INTEGER;
                        art:arttyp; tas:CHAR);
   VAR tasstr,npat:STRING;
       num,dummy:INTEGER;
       hrec:SearchRec;
   BEGIN
    tasstr:=tas;
    VAL(tasstr,num,dummy);
    num:=(posi+num)-1;
    IF num<=feld.belegt THEN
     BEGIN
      hrec:=feld.inhalt[num];
      WITH hrec DO
       BEGIN
        IF (hrec.Attr AND Directory)=0 THEN
         BEGIN {IF}
          nam:=hrec.name;
          at(37,9,nam);
         GOTOXY(37,9);
         END ELSE
         BEGIN
          npat:=name;
          WHILE pos(' ',npat)<>0 DO DELETE(npat,pos(' ',npat),1);
          IF npat[LENGTH(npat)]='.' THEN DELETE(npat,LENGTH(npat),1);
          INSERT('\'+npat,path,last_bs(path));
          prepare_screen(path,nam,feld,art);
          posi:=1;
          altposi:=0;
         END; {ELSE}
       END; {WITH}
     END; {IF}
   END;
  BEGIN
   prepare_screen(path,nam,feld,art);
   posi:=1;
   show(posi);
   altposi:=posi;
   REPEAT
    tas:=UPCASE(READKEY);
    IF keypressed THEN tas:=READKEY;
    CASE tas OF 'P' : INC(posi);
                'H' : DEC(posi);
                'Q' : posi:=posi+8;
                'I' : posi:=posi-8;
                'O' : posi:=feld.belegt-8;
                'G' : posi:=1;
        'N','E','S' : change_art(path,nam,posi,altposi,art,tas);
                '' : enter_path(path,nam,posi,altposi,art);
                '0' : enter_name(nam);
'1','2','3','4','5',
     '6','7','8','9': change_name(path,nam,posi,altposi,art,tas);
                #27 : close_folder(path,nam,posi,altposi,art);
             END;
    IF posi>feld.belegt-8 THEN posi:=feld.belegt-8;
    IF posi<1 THEN posi:=1;
    IF posi<>altposi THEN
     BEGIN
      altposi:=posi;
      show(posi);
     END;
   UNTIL tas IN [^m,'A'];
   abgebrochen:=(tas='A');
  END;

 BEGIN { fileselect-Main-PROCEDURE }
  save_all;
  NEW(feld);
  feld^.belegt:=0;
  prenam:='\'+prenam;
  nam:=COPY(prenam,last_bs(prenam)+1,255);
  fsel(path,nam,feld^,SortArt,cancel);
  hpath:=COPY(path,1,last_bs(path)-1);
  IF cancel THEN nam:='' ELSE
   BEGIN
    nam:=hpath+'\'+nam;
    WHILE pos(' ',nam)<>0 DO DELETE(nam,pos(' ',nam),1);
    IF hpath[LENGTH(hpath)]=':' THEN hpath:=hpath+'\';
    {$I-}
    IF PathHandle=auto THEN ChDir(hpath);
    {$I+}
    IF IoResult<>0 THEN
     BEGIN
      WRITELN('Error changing path, programme stopped.');
      halt;
     END;
   END;
  DISPOSE(feld);
  restore_all;
 END;

 FUNCTION ActivePath:STRING;
  VAR help:STRING;
  BEGIN
   GetDir(0,help);
   IF help[LENGTH(help)]<>'\' THEN help:=help+'\';
   ActivePath:=help;
  END;

 FUNCTION prepared:BOOLEAN; { Ist die BAR betriebsbereit? }
  BEGIN
   prepared:=men_ok;
  END;

 PROCEDURE fehler(was:STRING);
  BEGIN
   WRITELN('Fehler bei ',was);
   WRITELN('---> Programm abgebrochen');
   halt(2);
  END;

 PROCEDURE clear_bar;
  VAR x,y:INTEGER;
  BEGIN
   men_bar.anz:=0;
   FOR x:=1 TO 10 DO
    WITH men_bar.menu[x] DO
    BEGIN
     bar_pos[x].posi:=0;
     bar_pos[x].len:=0;
     men_name:='';
     eint_anz:=0;
     FOR y:=1 TO 10 DO
      BEGIN
       men_eint[y].txt:='';
       men_eint[y].wbar:=FALSE;
      END;
    END;
   act_menu:=1;
   men_ok:=FALSE;
  END;

 PROCEDURE make_menu(title,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10:STRING);
  VAR feh:STRING;
  PROCEDURE trage_ein(was:STRING; VAR wo:eint_typ);
   BEGIN
    wo.txt:=was;
    wo.wbar:=(was[1]<>'-');
   END;
  BEGIN
   feh:='MAKE_MENU: ';
   IF a1='' THEN fehler(feh+'Leeres Men.');
   IF title=''THEN fehler(feh+'Men-Name fehlt.');
   IF men_bar.anz=10 THEN fehler(feh+'Zu viele Mens.');
   IF prepared THEN fehler(feh+'Menzeile bereits erstellt.');
   INC(men_bar.anz);
   WITH men_bar.menu[men_bar.anz] DO
    BEGIN
     men_name:=title;
     eint_anz:=1;
     trage_ein(a1,men_eint[1]);
     IF a2<>'' THEN
      BEGIN
       eint_anz:=2;
       trage_ein(a2,men_eint[2]);
       IF a3<>'' THEN
        BEGIN
         eint_anz:=3;
         trage_ein(a3,men_eint[3]);
         IF a4<>'' THEN
          BEGIN
           eint_anz:=4;
           trage_ein(a4,men_eint[4]);
           IF a5<>'' THEN
            BEGIN
             eint_anz:=5;
             trage_ein(a5,men_eint[5]);
             IF a6<>'' THEN
              BEGIN
               eint_anz:=6;
               trage_ein(a6,men_eint[6]);
               IF a7<>'' THEN
                BEGIN
                 eint_anz:=7;
                 trage_ein(a7,men_eint[7]);
                 IF a8<>'' THEN
                  BEGIN
                   eint_anz:=8;
                   trage_ein(a8,men_eint[8]);
                   IF a9<>'' THEN
                    BEGIN
                     eint_anz:=9;
                     trage_ein(a9,men_eint[9]);
                     IF a10<>'' THEN
                      BEGIN
                       eint_anz:=10;
                       trage_ein(a10,men_eint[10]);
                      END;
                    END;
                  END;
                END;
              END;
            END;
          END;
        END;
      END;
    END;
  END;

 PROCEDURE make_bar;
  VAR feh:STRING;
      x:INTEGER;
  PROCEDURE berechne_bar_pos(x:INTEGER);
   VAR maxlen,y:INTEGER;
   BEGIN
    WITH men_bar.menu[x] DO
     BEGIN
      maxlen:=Length(men_eint[1].txt);
      FOR y:=1 TO eint_anz DO
       IF Length(men_eint[y].txt)>maxlen THEN maxlen:=Length(men_eint[y].txt);
      maxlen:=maxlen+2;
      IF bar_pos[x].posi+maxlen>81 THEN bar_pos[x].posi:=81-maxlen;
      bar_pos[x].len:=maxlen;
     END;
   END;
  BEGIN
   feh:='MAKE_BAR: ';
   IF (men_bar.anz=0) THEN fehler(feh+'Kein Men.');
   bar_line:='';
   FOR x:=1 TO men_bar.anz DO
    BEGIN
     bar_pos[x].posi:=Length(bar_line)+1;
     bar_line:=bar_line+' '+men_bar.menu[x].men_name;
     berechne_bar_pos(x);
    END;
   IF Length(bar_line)>80 THEN fehler(feh+'Menzeile zu lang.');
   bar_line:=bar_line+strg(' ',80-Length(bar_line));
   men_ok:=TRUE;
  END;

 PROCEDURE do_menu(VAR men_nr,eint_nr:INTEGER);
  VAR tem_scr:bildptr;
      tas:CHAR;
      gewaehlt:BOOLEAN;
  PROCEDURE draw_men(x:INTEGER);
   VAR y:INTEGER;
   BEGIN
    WITH men_bar.menu[x] DO
     BEGIN
      GOTOXY(bar_pos[x].posi+1,1);
      TextAttr:=7;
      WRITE(men_name);
      TextAttr:=7;
      draw_box(bar_pos[x].posi,2,bar_pos[x].len,eint_anz+2,1);
      FOR y:=1 TO eint_anz DO
       BEGIN
        GOTOXY(bar_pos[x].posi+1,2+y);
        IF men_eint[y].wbar THEN TextAttr:=15 ELSE TextAttr:=7;
        WRITE(men_eint[y].txt);
       END;
     END;
   END;
  PROCEDURE draw_bar(x:INTEGER);
   BEGIN
    TextAttr:=112;
    GOTOXY(1,1);
    WRITELN(bar_line);
    IF x<>0 THEN
     BEGIN
      GOTOXY(bar_pos[x].posi+1,1);
      TextAttr:=15;
      WRITELN(men_bar.menu[x].men_name);
     END;
   END;
  PROCEDURE do_single(act:INTEGER; VAR men,eint:INTEGER; VAR sel:BOOLEAN);
   VAR tas:CHAR;
       oldpos:INTEGER;
   BEGIN
    draw_men(act);
    men:=act;
    oldpos:=1;
    eint:=1;
    REPEAT
     REPEAT
      GOTOXY(bar_pos[men].posi+1,2+oldpos);
      WITH men_bar.menu[men] DO
       BEGIN
        GOTOXY(bar_pos[men].posi+1,2+oldpos);
        IF men_eint[oldpos].wbar THEN TextAttr:=15 ELSE TextAttr:=7;
        WRITE(men_eint[oldpos].txt);
        oldpos:=eint;
        GOTOXY(bar_pos[men].posi+1,2+eint);
        IF men_eint[oldpos].wbar THEN TextAttr:=120 ELSE TextAttr:=112;
        WRITE(men_eint[eint].txt);
       END;
      tas:=READKEY;
      IF keypressed THEN tas:=READKEY
                    ELSE IF NOT (tas IN [#27,^m]) THEN tas:=' ';
     UNTIL tas IN [#27,'H','P',^m];
     CASE tas OF 'H' : DEC(eint);
                 'P' : INC(eint);
              END;
     IF eint<1 THEN eint:=men_bar.menu[men].eint_anz;
     IF eint>men_bar.menu[men].eint_anz THEN eint:=1;
     IF (tas=^m) AND NOT men_bar.menu[men].men_eint[oldpos].wbar THEN
      BEGIN
       tas:=' ';
       WRITE(#7);
      END;
    UNTIL tas IN [#27,^m];
    IF tas=^m THEN sel:=TRUE;
   END;
  BEGIN
   IF prepared THEN
    BEGIN
     save_all;
     draw_bar(0);
     NEW(tem_scr);
     SGET(tem_scr^);
     gewaehlt:=FALSE;
     REPEAT
      SPUT(tem_scr^);
      draw_bar(act_menu);
      REPEAT
       tas:=READKEY;
       IF keypressed THEN tas:=READKEY
                     ELSE IF NOT (tas IN [#27,^m]) THEN tas:=' ';
      UNTIL tas IN [#27,'K','M','P',^m];
      CASE tas OF 'K' : DEC(act_menu);
                  'M' : INC(act_menu);
                  'P',^m : do_single(act_menu,men_nr,eint_nr,gewaehlt);
               END;
      IF act_menu<1 THEN act_menu:=men_bar.anz;
      IF act_menu>men_bar.anz THEN act_menu:=1;
     UNTIL (tas=#27) OR gewaehlt;
     IF tas=#27 THEN
      BEGIN
       men_nr:=0;
       eint_nr:=0;
      END;
     DISPOSE(tem_scr);
     restore_all;
    END ELSE fehler('DO_MENU: Men-Zeile nicht vorbereitet.');
  END;

 PROCEDURE check_menu(men_nr,eint_nr:INTEGER; feh:STRING);
  BEGIN
   IF NOT prepared THEN fehler(feh+'Men-Zeile nicht vorbereitet.');
   IF (men_nr<1) OR (men_nr>10) THEN fehler(feh+'Illegales Men');
   IF (eint_nr<1) OR (eint_nr>10) THEN fehler(feh+'Illegaler Men-Punkt');
   IF men_bar.anz<men_nr THEN fehler(feh+'Men nicht vorhanden');
   IF men_bar.menu[men_nr].eint_anz<eint_nr
      THEN fehler(feh+'Menpunkt nicht vorhanden');
  END;

 PROCEDURE selectable(men_nr,eint_nr:INTEGER);
  BEGIN
   check_menu(men_nr,eint_nr,'SELECTABLE: ');
   men_bar.menu[men_nr].men_eint[eint_nr].wbar:=TRUE;
  END;

 PROCEDURE unselectable(men_nr,eint_nr:INTEGER);
  BEGIN
   check_menu(men_nr,eint_nr,'UNSELECTABLE: ');
   men_bar.menu[men_nr].men_eint[eint_nr].wbar:=FALSE;
  END;

 FUNCTION men_text(men,eint:INTEGER):STRING;
  BEGIN
   IF (men=0) AND (eint=0) THEN men_text:='ESC -> Abbruch' ELSE
    BEGIN
     check_menu(men,eint,'MEN_TEXT: ');
     men_text:=men_bar.menu[men].men_eint[eint].txt;
    END;
  END;

 BEGIN { INIT-Schleife fr Unit ATARI}
  clear_bar;
  NEW(oldscreen);
 END.