PROGRAM toe; { V 1.02 - Strategie-Bug korrigiert, sorry! }

(* Tic Tac Toe!, wohl eines der dmmsten Spiele, die ich kenne, aber
   immerhin PD. (C) by ONKISOFT 1999, also Gero Zahn
                                           Bergring 27
                                         D-4953 Petershagen
                                           Tel.: 05707/2501
   Dieses Programm enstand aus einer Wette heraus: Ein Freund von mir
   und ich wollten beide (autonom) Toe implementieren, und der, dessen
   Algorithmus gewann, bekam eine Cola. Ich glaube, es ergab ein
   Unentschieden ... Zumindest meine grafische Realisation war besser,
   aufgrund des Units LOWGRAPH, als dessen Demo ich dieses Programm
   normalerweise verbreite. Man sieht: Man mu nicht immer gleich in
   den HighRes-Mode, um ein wenig Eindruck zu schinden.
   P.S.: Das Unit TITLE beinhaltet keinerlei Prozeduren sondern zeigt
   (ohne Zutun des Nutzers) ein Titelbild von mir. Source-Text bei mir! *)

 uses title,crt,lowgraph;

 CONST splr='X';
       cmptr='O';
       posi=24;

 TYPE krkr=(kreuz,kreis,leer);
      feldtyp=ARRAY [1..3,1..3] OF krkr;
      zugtyp=ARRAY [1..9] OF RECORD x,y:BYTE END;

 VAR zug:zugtyp;
     feld:feldtyp;
     durchgang:BYTE;
     ende:krkr;
     anfang:BYTE;

 PROCEDURE init_feld(VAR spiel:feldtyp);
  VAR fix,fiy:BYTE;
  BEGIN
   FOR fix:=1 TO 3 DO FOR fiy:=1 TO 3 DO spiel[fix,fiy]:=leer;
  END;

 PROCEDURE init_zuege(VAR zuege:zugtyp);
  VAR iz:BYTE;
  BEGIN
   FOR iz:=1 TO 9 DO
    BEGIN
     zuege[iz].x:=0;
     zuege[iz].y:=0;
    END;
  END;

 PROCEDURE init_ausgabe;
  BEGIN
   LOWVIDEO;
   CLRSCR;
   HIGHVIDEO;
   GOTOXY(1,posi);
   line(13,1,13,42,1);
   line(27,1,27,42,1);
   line(1,15,40,15,1);
   line(1,29,40,29,1);
  END;

 PROCEDURE ausgabe(ff:zugtyp;durch:BYTE);
  VAR xc,yc:BYTE;
  BEGIN
   xc:=6+14*(ff[durch].x-1);
   yc:=8+14*(ff[durch].y-1);
   IF durch MOD 2=anfang THEN
    BEGIN
     line(xc+5,yc+5,xc-5,yc-5,1);
     line(xc-5,yc+5,xc+5,yc-5,1);
    END ELSE ellipse(xc,yc,5,5,1);
  END;

 PROCEDURE spielzug(game:BYTE;VAR zuege:zugtyp;VAR spiel:feldtyp;
                    VAR gewinn:krkr);
  FUNCTION ee(xx,yy:BYTE):BOOLEAN;
   BEGIN;
    ee:=(spiel[xx,yy]=leer);
   END;
  FUNCTION ei(xx,yy:BYTE):BOOLEAN;
   BEGIN;
    ei:=(spiel[xx,yy]=kreis);
   END;
  FUNCTION eu(xx,yy:BYTE):BOOLEAN;
   BEGIN;
    eu:=(spiel[xx,yy]=kreuz);
   END;
  PROCEDURE spieler;
   VAR zugx,zugy:BYTE;
       tas:CHAR;
   BEGIN
    zugx:=2;
    zugy:=2;
    REPEAT
     REPEAT
      GOTOXY(6+14*(zugx-1),4+7*(zugy-1));
      tas:=READKEY;
      IF (tas=#0) AND KEYPRESSED THEN tas:=READKEY;
      CASE tas OF 'M' : zugx:=zugx+1;
                  'K' : zugx:=zugx-1;
                  'P' : zugy:=zugy+1;
                  'H' : zugy:=zugy-1;
                  'G' : BEGIN
                         zugx:=zugx-1;
                         zugy:=zugy-1;
                        END;
                  'Q' : BEGIN
                         zugx:=zugx+1;
                         zugy:=zugy+1;
                        END;
                  'O' : BEGIN
                         zugx:=zugx-1;
                         zugy:=zugy+1;
                        END;
                  'I' : BEGIN
                         zugx:=zugx+1;
                         zugy:=zugy-1;
                        END;
               END;
      CASE zugx OF 4 : zugx:=1;
                   0 : zugx:=3;
                END;
      CASE zugy OF 4 : zugy:=1;
                   0 : zugy:=3;
                END;
     UNTIL tas=^m;
    UNTIL ee(zugx,zugy);
    spiel[zugx,zugy]:=kreuz;
    zuege[game].x:=zugx;
    zuege[game].y:=zugy;
    GOTOXY(1,posi);
   END;
  PROCEDURE computer;
   VAR zugx,zugy:BYTE;
   PROCEDURE att_seq(ax,ay,bx,by,cx,cy:BYTE;
             typ:krkr; VAR freix,freiy:BYTE);
    BEGIN
     freix:=0;
     freiy:=0;
     IF (spiel[ax,ay]=typ) AND (spiel[bx,by]=typ)
      AND ee(cx,cy) THEN
       BEGIN
        freix:=cx;
        freiy:=cy;
       END;
     IF (spiel[ax,ay]=typ) AND (spiel[cx,cy]=typ)
      AND ee(bx,by) THEN
       BEGIN
        freix:=bx;
        freiy:=by;
       END;
     IF (spiel[cx,cy]=typ) AND (spiel[bx,by]=typ)
      AND ee(ax,ay) THEN
       BEGIN
        freix:=ax;
        freiy:=ay;
       END;
    END;
   PROCEDURE defense(VAR dx,dy:BYTE);
    BEGIN
     dx:=0;
     dy:=0;
     IF dx=0 THEN att_seq(1,1,2,1,3,1,kreuz,dx,dy);
     IF dx=0 THEN att_seq(1,1,1,2,1,3,kreuz,dx,dy);
     IF dx=0 THEN att_seq(1,2,2,2,3,2,kreuz,dx,dy);
     IF dx=0 THEN att_seq(2,1,2,2,2,3,kreuz,dx,dy);
     IF dx=0 THEN att_seq(1,3,2,3,3,3,kreuz,dx,dy);
     IF dx=0 THEN att_seq(3,1,3,2,3,3,kreuz,dx,dy);
     IF dx=0 THEN att_seq(1,1,2,2,3,3,kreuz,dx,dy);
     IF dx=0 THEN att_seq(3,1,2,2,1,3,kreuz,dx,dy);
    END;
   PROCEDURE atta(VAR dx,dy:BYTE);
    BEGIN
     dx:=0;
     dy:=0;
     IF dx=0 THEN att_seq(1,1,2,1,3,1,kreis,dx,dy);
     IF dx=0 THEN att_seq(1,1,1,2,1,3,kreis,dx,dy);
     IF dx=0 THEN att_seq(1,2,2,2,3,2,kreis,dx,dy);
     IF dx=0 THEN att_seq(2,1,2,2,2,3,kreis,dx,dy);
     IF dx=0 THEN att_seq(1,3,2,3,3,3,kreis,dx,dy);
     IF dx=0 THEN att_seq(3,1,3,2,3,3,kreis,dx,dy);
     IF dx=0 THEN att_seq(1,1,2,2,3,3,kreis,dx,dy);
     IF dx=0 THEN att_seq(3,1,2,2,1,3,kreis,dx,dy);
    END;
   FUNCTION kante(zg:BYTE):BOOLEAN;
    VAR px,py:BYTE;
    BEGIN
     px:=zuege[zg].x;
     py:=zuege[zg].y;
     kante:=false;
     IF ((px=1) OR (px=3)) AND (py=2) THEN kante:=TRUE;
     IF (px=2) AND ((py=1) OR (py=3)) THEN kante:=TRUE;
    END;
   FUNCTION ecke(zg:BYTE):BOOLEAN;
    VAR px,py:BYTE;
    BEGIN
     px:=zuege[zg].x;
     py:=zuege[zg].y;
     ecke:=false;
     IF ((px=1) OR (px=3)) AND ((py=1) OR (py=3)) THEN ecke:=TRUE;
    END;
   PROCEDURE attack;
    PROCEDURE wenn_frei(xp,yp:BYTE;VAR zx,zy:BYTE);
     BEGIN
      IF ee(xp,yp) THEN
       BEGIN
        zx:=xp;
        zy:=yp;
       END;
     END;
    PROCEDURE setze_ecke(VAR zx,zy:BYTE);
     VAR stop:BOOLEAN;
     PROCEDURE zufall_ecke(VAR zx,zy:BYTE);
      BEGIN
       IF zx=0 THEN wenn_frei(1,1,zx,zy); { Mir fiel kein Zufalls- }
       IF zx=0 THEN wenn_frei(1,3,zx,zy); { Algorithmus eins ...   }
       IF zx=0 THEN wenn_frei(3,1,zx,zy);
       IF zx=0 THEN wenn_frei(3,3,zx,zy);
      END;
     BEGIN
      stop:=false;
      IF ((eu(1,1) AND eu(3,3)) OR (eu(1,1) AND eu(3,3)))
         AND (game=4) THEN stop:=true;
      IF NOT stop THEN
       BEGIN
        IF (eu(1,2) AND eu(2,1)) OR
           (eu(3,3) AND (eu(1,2) OR eu(2,1)))
           THEN wenn_frei(1,1,zx,zy) ELSE
        IF (eu(1,2) AND eu(2,3)) OR
           (eu(3,1) AND (eu(1,2) OR eu(2,3)))
           THEN wenn_frei(1,3,zx,zy) ELSE
        IF (eu(3,2) AND eu(2,1)) OR
           (eu(1,3) AND (eu(3,2) OR eu(2,1)))
           THEN wenn_frei(3,1,zx,zy) ELSE
        IF (eu(3,2) AND eu(2,3)) OR
           (eu(1,1) AND (eu(3,2) OR eu(2,3)))
           THEN wenn_frei(3,3,zx,zy) ELSE
        zufall_ecke(zx,zy);
       END;
     END;
    PROCEDURE setze_kante(VAR zx,zy:BYTE);
     PROCEDURE zufall_kante(VAR zx,zy:BYTE);
      BEGIN
       IF zx=0 THEN wenn_frei(1,2,zx,zy); { Mir fiel keine Zufalls- }
       IF zx=0 THEN wenn_frei(2,1,zx,zy); { Algorithmus ein ...     }
       IF zx=0 THEN wenn_frei(3,2,zx,zy);
       IF zx=0 THEN wenn_frei(2,3,zx,zy);
      END;
     BEGIN
      zufall_kante(zx,zy);
     END;
    BEGIN
     IF anfang=0 THEN
      BEGIN
       IF game=1 THEN
        BEGIN
         zugx:=2;
         zugy:=2;
        END;
       IF kante(2) THEN
        CASE game OF 3 : BEGIN
                          IF zuege[2].x=2 THEN
                           BEGIN
                            zugx:=3-2*RANDOM(2);
                            zugy:=zuege[2].y;
                           END ELSE
                           BEGIN
                            zugx:=zuege[2].x;
                            zugy:=3-2*RANDOM(2);
                           END;
                         END;
                     5 : BEGIN
                          IF zuege[2].x=2 THEN
                           BEGIN
                            zugx:=zuege[3].x;
                            zugy:=2;
                           END ELSE
                           BEGIN
                            zugx:=2;
                            zugy:=zuege[3].y;
                           END;
                         END;
                  END
       ELSE
        CASE game OF 3 : BEGIN
                          zugx:=4-zuege[2].x;
                          zugy:=4-zuege[2].y;
                         END;
                     5 : BEGIN
                          IF kante(4) THEN
                           BEGIN
                            IF zuege[4].x=2 THEN
                             BEGIN
                              zugx:=zuege[3].x;
                              zugy:=2;
                             END ELSE
                             BEGIN
                              zugx:=2;
                              zugy:=zuege[3].y;
                             END;
                           END;
                         END;
                     7 : BEGIN
                          IF zuege[6].x=2 THEN
                           BEGIN
                            zugx:=4-zuege[4].x;
                            zugy:=2;
                           END ELSE
                           BEGIN
                            zugx:=2;
                            zugy:=4-zuege[4].y;
                           END
                         END;
                     9 : BEGIN
                          zugx:=4-zuege[4].x;
                          zugy:=4-zuege[4].y;
                         END;
                  END;
      END
     ELSE
      BEGIN
       IF zugx=0 THEN wenn_frei(2,2,zugx,zugy); { Prioritt: Mitte, }
       IF zugx=0 THEN setze_ecke(zugx,zugy);    {            Ecke,  }
       IF zugx=0 THEN setze_kante(zugx,zugy);   {            Kante. }
      END;
    END;
   BEGIN
    zugx:=0;
    zugy:=0;
    atta(zugx,zugy);
    IF zugx=0 THEN defense(zugx,zugy);
    IF zugx=0 THEN attack;
    spiel[zugx,zugy]:=kreis;
    zuege[game].x:=zugx;
    zuege[game].y:=zugy;
   END;
  PROCEDURE test(VAR gew:krkr);
   FUNCTION gew_seq(ax,ay,bx,by,cx,cy:BYTE):krkr;
    BEGIN
     gew_seq:=leer;
     IF (spiel[ax,ay]=spiel[bx,by]) AND (spiel[bx,by]=spiel[cx,cy])
      THEN gew_seq:=spiel[ax,ay];
    END;
   BEGIN
    gew:=leer;
    IF gew=leer THEN gew:=gew_seq(1,1,2,2,3,3);
    IF gew=leer THEN gew:=gew_seq(1,3,2,2,3,1);
    IF gew=leer THEN gew:=gew_seq(1,1,1,2,1,3);
    IF gew=leer THEN gew:=gew_seq(2,1,2,2,2,3);
    IF gew=leer THEN gew:=gew_seq(3,1,3,2,3,3);
    IF gew=leer THEN gew:=gew_seq(1,1,2,1,3,1);
    IF gew=leer THEN gew:=gew_seq(1,2,2,2,3,2);
    IF gew=leer THEN gew:=gew_seq(1,3,2,3,3,3);
   END;
  BEGIN
   IF game MOD 2=anfang THEN spieler ELSE computer;
   ausgabe(zuege,game);
   test(gewinn);
  END;

 PROCEDURE zeige_spielregeln;
  BEGIN
   TEXTBACKGROUND(0);
   TEXTCOLOR(15);
   CLRSCR;
   init_ausgabe;
   GOTOXY(10,5);
   WRITE('TIC-TAC-TOE!');
   invert;
   invert;
   DELAY(1500);
   GOTOXY(5,9);
   WRITE('Bei diesem Spiel steht vor allem');
   DELAY(500); 
   GOTOXY(5,10);
   WRITE('die Strategie im Vordergrung.');
   DELAY(1000); 
   GOTOXY(5,16);
   WRITE('Sie setzen Kreuze, der Computer Kreise.');
   DELAY(500); 
   GOTOXY(5,17);
   WRITE('Wer drei seiner Zeichen in einer Reihe hat, gewinnt!');
   DELAY(500); 
   GOTOXY(5,19);
   WRITE('(Aber das ist nicht ganz einfach!)');
   DELAY(2000);
  END;

 PROCEDURE bestimme (VAR anf:BYTE);
  VAR tas:CHAR;
  BEGIN
   GOTOXY(1,posi);
   WRITE('Wer soll beginnen, der <S>pieler oder der <C>omputer? ');
   REPEAT
    tas:=UPCASE(READKEY);
   UNTIL tas IN ['S','C'];
   WRITE(tas);
   anf:=0;
   IF tas='S' THEN anf:=1;
  END;

 FUNCTION nochmal:BOOLEAN;
  VAR ntas:CHAR;
  BEGIN
   GOTOXY(12,11);
   WRITE('Noch ein Spiel? ');
   REPEAT
    ntas:=UPCASE(READKEY);
   UNTIL ntas IN ['J','N'];
   nochmal:=(ntas='J');
   WRITE(ntas);
   CLRSCR;
  END;

 BEGIN {Main}
  checkbreak:=false;
  zeige_spielregeln;
  REPEAT
   bestimme (anfang);
   init_feld(feld);
   init_zuege(zug);
   init_ausgabe;
   ende:=leer;
   FOR durchgang:=1 TO 9 DO IF ende=leer
    THEN spielzug(durchgang,zug,feld,ende);
   GOTOXY(1,posi);
   CASE ende OF leer : WRITE('Kein ');
                kreuz : WRITE('Der Spieler ist der ');
                kreis : WRITE('Der Computer ist der ');
             END;
   WRITELN('Gewinner.');
  UNTIL NOT(nochmal);
  NormVideo;
  ClrScr;
 END.